/**
 * @file
 * Grid implementation.
 *
 * @copyright Copyright © 2017–2018 Magneson.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#include "node.h"

VuoModuleMetadata({
                     "title" : "Make 2d Point Grid",
					 "keywords" : [ ],
					 "version" : "1.0.0",
					 "dependencies" : [ ],
					 "node": {
                          "exampleCompositions" : [ "LayerGrid.vuo" ]
					 }
				 });

void nodeEvent
(
        VuoInputData(VuoInteger, {"default": 10}) xAmount,
        VuoInputData(VuoInteger, {"default": 10}) yAmount,
        VuoInputData(VuoPoint2d, {"default":{"x":-0.5, "y":0.5},"suggestedMin":{"x":-1.0, "y":-1.0}, "suggestedMax":{"x":1.0, "y":1.0}}) rangeFrom,
        VuoInputData(VuoPoint2d, {"default":{"x":0.5, "y":-0.5},"suggestedMin":{"x":-1.0, "y":-1.0}, "suggestedMax":{"x":1.0, "y":1.0}}}) rangeTo,
        VuoInputData(VuoCurve, {"default":"linear"}) curveX,
        VuoInputData(VuoCurve, {"default":"linear"}) curveY,
        VuoInputData(VuoCurveEasing, {"default":"in"}) easingX,
        VuoInputData(VuoCurveEasing, {"default":"in"}) easingY,
        VuoOutputData(VuoList_VuoPoint2d) list
)
{
    //Create the output list
    *list = VuoListCreate_VuoPoint2d();

    //Calculate points

    for(unsigned int i = 0; i < yAmount; ++i){
        for(unsigned int j = 0; j < xAmount; ++j){

            VuoReal x = VuoReal_curve(j, rangeFrom.x, rangeTo.x, (xAmount - 1), curveX, easingX, VuoLoopType_None);
            VuoReal y = VuoReal_curve(i, rangeFrom.y, rangeTo.y, (yAmount - 1), curveY, easingY, VuoLoopType_None);

            VuoListAppendValue_VuoPoint2d(*list, VuoPoint2d_make(x, y));
        }
    }
}
